package jadex.idgenerator;

import java.lang.String;
import java.util.Arrays;

public class Words {
  public static final String[] ADJECTIVES = {"Abandoned","Abating","Abbreviated","Abecedarian ","Aberrant","Abiding","Ablaze","Abloom","Abounding","Abrasive","Abrupt","Absent","Absolute","Absorbing","Absquatulate","Abstergent","Absurd","Abundant","Academic","Accelerated","Acceptable","Acceptant","Accepting","Accessible","Accidental","Acclaimed","Accommodating","Accomplished","Accordant","Accountable","Accredited","Accurate","Accursed","Accused","Accusing","Accustomed","Achieving","Acidic","Acknowledged","Acoustic","Acquainted","Acrid","Acrobatic","Actionable","Acuminous","Adamant","Adamantine","Adaptable","Adaptive","Additional","Addle","Addorsed","Adept","Adequate","Adherent","Adhering","Adhesive","Adjacent","Adjoining","Adjustable","Adjusted","Adjuvant","Administrative","Admired","Admissible","Adorable","Adored","Adoring","Adrenalized","Adroit","Adulatory","Adult","Advanced","Advantaged","Advantageous","Adventuresome","Adventurous","Adversarial","Adverse","Advisable","Advised","Aerial","Aesthetic","Aesthetical","Afeard","Affable","Affecting","Affectionate","Affective","Affiliated","Affirmative","Affluent","Affluential","Affordable","Afraid","Aged","Ageless","Aggravating","Aggressive","Agile","Aging","Agitated","Aglow","Agog","Agrarian","Agreeable","Agreeing","Aimedless","Aimless","Airy","Alacritous","Alarmed","Alarming","Alated","Aleatory","Algebraic","Alien","Alight","Alike","Alimental","Alive","Alleged","Allegiant","Allegorical","Allowable","Alluring","Allusive","Almighty","Alone","Alternating","Alternative","Altruistic","Amaranthine","Amatory","Amazed","Amazing","Ambidextrous","Ambiguous","Ambitious","Ambivalent","Ambrosial","Ameliorative","Amenable","Amiable","Amicable","Amorous","Amorphous","Amort","Amphibian","Amused","Amusing","Ancient","Angelic","Angered","Angry","Angular","Animalistic","Animated","Animistic","Anklebiting","Annoyed","Annoying","Annual","Anonymous","Another","Antagonistic","Antediluvian","Anticipated","Anticipated","Anticipating","Anticorrosive","Anticsridden","Antiquated","Antsy","Anxious","Apathetic","Aplenty","Apologetic","Apologizing","Apotheosized","Appealing","Appeasing","Appetizing","Applauding","Applicable","Appreciated","Appreciative","Apprehensive","Approachable","Appropriate","Approving","Approximate","Apt","Aquatic","Ardent","Argumentative","Arid","Armored","Aromatic","Arrested","Arresting","Arrogant","Artful","Articulate","Artificial","Artistic","Artless","Ashamed","Ashen","Asinine","Askew","Aspiring","Assertive","Assignable","Assisting","Assorted","Assumable","Assured","Assurgent","Assuring","Astonished","Astonishing","Astounded","Astounding","Astringent","Astronomical","Asymmetrical","Ataractic","Athletic","Atmospheric","Atomic","Atrocious","Attachable","Attainable","Attentive","Attractive","Attributable","Attributive","Atypical","Audacious","August","Auspicious","Australian","Authentic","Authoritative","Automatic","Autonomous","Available","Avenging","Average","Avid","Avoidable","Awakening","Aware","Awed","Awesome","Baboonish","Babyish","Bacciferous","Baffled","Bahamian","Bailable","Balanceable","Balanced","Balderdash","Bald-faced","Ballsy","Balmy","Balsamic","Baltic","Bamboozled","Bamboozling","Banal","Barbecued","Barbed","Barbequed","Bardic","Barmy","Barnlike","Barometric","Baronial","Baroque","Basic","Basined","Basque","Beaconless","Beady","Beaming","Bearable","Beardless","Bearing","Bearish","Beatific","Beautiful","Beavered","Becalmed","Becoming","Bedaubed","Bedazzled","Bedfast","Bedimmed","Bedouin","Bedraggled","Beefy","Beethovenian","Befuddled","Befuddling","Beguiling","Behavioral","Behavioristic","Beholden","Beige","Bejeweled","Belching","Belgian","Believable","Beloved","Benedictory","Beneficial","Benevolent","Benighted","Benign","Benignant","Beninese","Bent","Benthal","Bequeathable","Bereaved","Bereft","Bermudan","Bernese","Berried","Berrylike","Beseeming","Besotted","Bespectacled","Best","Bestubbled","Betrothed","Bewhiskered","Bewildered","Bewitching","Biased","Bibacious","Bibliographical","Bibliomaniacal","Bibliophilic","Bibulous","Bicentennial","Bidirectional","Bifocal","Bifold","Biforked","Big","Bigmouthed","Binal","Bioactive","Birchen","Bisexuality","Bite-sized","Bitter","Bizarre","Bizonal","Blabbermouth","Blabby","Blackened","Blackish","Bladderlike","Bladdery","Bladed","Bladelike","Blady","Blameful","Blameless","Blameworthy","Blanched","Bland","Blandiloquent","Blanket","Blaring","Blase","Blaspheming","Blasphemous","Blasted","Blasting","Blasty","Blatant","Blazing","Bleak","Bleary-eyed","Blessed","Blest","Blighted","Blighting","Blissful","Blistering","Blithe","Blithering","Blooming","Blotto","Bloviate","Blowzy","Blubbering","Blubbery","Blueish","Blue-ribbon","Blundering","Blushful","Blushing","Blushless","Blustering","Blusterous","Boardable","Boatable","Bodacious","Bold","Bombastic","Bonny","Bonzer","Boobyish","Bookable","Boon","Boring","Bosom","Botanical","Botched","Boughless","Bouncing","Bouncy","Boundary","Boundless","Bountiful","Bourgeois","Boxen","Brachial","Brackish","Braggy","Braided","Brainish","Brainless","Brainsick","Brainwashed","Brainy","Braised","Braky","Braless","Branchial","Branchless","Branchy","Branny","Brassbound","Brasslike","Brassy","Brattish","Bratty","Brave","Brawling","Brawny","Braying","Breakable","Breakaway","Breasted","Breathable","Brecciated","Breeding","Breezeless","Breezy","Brief","Bright","Brill","Brilliant","Brimful","Brimless","Brimming","Brisk","Broad","Brotherlike","Brotherly","Brouhaha","Bubbly","Bubonic","Buccal","Buccaneering","Buckish","Budding","Budget","Buffoon","Buffoonish","Buffy","Bulgarian","Bulging","Bulgy","Bulimic","Bulky","Bulletproof","Bullheaded","Bullish","Bullnecked","Bumbershoot","Bumblebee","Bumbling","Bumfuzzled","Bumptious","Buoyant","Burbly","Burdenless","Burdensome","Bureaucratical","Burgeoning","Burghal","Burled","Burly","Daffy","Deformed","Devious","Dishonest","Doable","Daft","Dishonorable","Documentary","Daily","Disillusioned","Dogged","Dainty","Dehydrated","Dexterous","Disinclined","Damaged","Dejected","Diabolical","Disingenuous","Dogmatic","Damaging","Delectable","Diagonal","Disinterested","Doleful","Damp","Deliberate","Didactic","Dollish","Danceable","Deliberative","Different","Dislikeable","Domed","Dandy","Delicate","Difficult","Disliked","Domestic","Dangerous","Delicious","Diffuse","Disloyal","Dapper","Delighted","Digestive","Dismal","Domineering","Daring","Delightful","Digital","Dismissive","Dorsal","Dark","Delinquent","Dignified","Disobedient","Doting","Darkened","Delirious","Digressive","Disorderly","Double","Dashing","Deliverable","Dilapidated","Disorganized","Doubtful","Daughterly","Deluded","Diligent","Doubting","Daunting","Demanding","Dim","Disparate","Dovish","Dawdling","Diminishing","Dispassionate","Dowdy","Democratic","Diminutive","Dispensable","Down","Dazed","Demonic","Dingy","Displaced","Dazzling","Demonstrative","Diplomatic","Displeased","Downhearted","Dead","Demure","Dire","Displeasing","Downloadable","Deadly","Deniable","Direct","Disposable","Downtown","Deadpan","Dense","Direful","Disproportionate","Downward","Deaf","Dependable","Dirty","Disproved","Dozing","Deafening","Dependent","Disabled","Disputable","Drab","Dear","Deplorable","Disadvantaged","Disputatious","Drained","Debatable","Deploring","Disadvantageous","Disputed","Dramatic","Debonair","Depraved","Disaffected","Disreputable","Dreaded","Decadent","Depressed","Disagreeable","Disrespectful","Dreadful","Decayed","Depressing","Disappointed","Dissatisfied","Dreaming","Deceitful","Deprived","Disappointing","Dissimilar","Dreamy","Deceivable","Deranged","Disapproving","Dissolvable","Dreary","Deceiving","Derivative","Disarming","Dissolving","Drenched","Decent","Derogative","Disastrous","Dissonant","Dress","Decentralized","Derogatory","Discarded","Deserted","Disciplined","Distasteful","Dripping","Decipherable","Disconnected","Distinct","Drivable","Decisive","Desirable","Distinctive","Driven","Declining","Desirous","Discordant","Distinguished","Droll","Decorative","Desolate","Discouraged","Distracted","Drooping","Decorous","Despairing","Discouraging","Distraught","Drowsy","Discredited","Distressed","Drunk","Dedicated","Despised","Discreet","Distressing","Dry","Deep","Despondent","Distrustful","Dual","Deepening","Destroyed","Disturbed","Dubious","Defeated","Destructive","Discussable","Disturbing","Due","Defective","Detachable","Divergent","Defendable","Detached","Diseased","Diverging","Dull","Defenseless","Detailed","Disenchanted","Diverse","Duplicitous","Defensible","Detectable","Diversified","Durable","Defensive","Determined","Disgruntled","Divided","Dusty","Defiant","Divine","Dutiful","Deficient","Detrimental","Disgusting","Divisive","Dwarfish","Definable","Devastated","Disheartened","Dizzy","Dwindling","Definitive","Devastating","Disheartening","Dizzying","Dynamic","Dysfunctional","Fabled","Favorite","First","Fond","Freezing","Fabulous","Fawning","Fiscal","Foolhardy","Frequent","Facetious","Feared","Fishy","Foolish","Fresh","Facial","Fearful","Fit","Forbidding","Fretful","Factitious","Fearless","Fitted","Forceful","Fried","Factual","Fearsome","Fitting","Foreboding","Friendly","Faded","Feathered","Foregoing","Frightened","Fading","Feathery","Fixable","Foreign","Frightening","Failed","Feckless","Fixed","Forensic","Frightful","Faint","Federal","Flabby","Foreseeable","Frigid","Fainthearted","Feeble","Flagrant","Forged","Frilly","Fair","Flaky","Forgetful","Frisky","Faithful","Feeling","Flamboyant","Forgettable","Frivolous","Faithless","Feigned","Flaming","Forgivable","Front","Fallacious","Felonious","Flammable","Forgiving","Frosty","False","Female","Flashy","Forgotten","Frothy","Falsified","Feminine","Flat","Forked","Frowning","Faltering","Fermented","Flattened","Formal","Frozen","Familiar","Ferocious","Flattered","Formative","Frugal","Famished","Flattering","Former","Fruitful","Famous","Fervent","Flavored","Formidable","Fruitless","Fervid","Flavorful","Formless","Fruity","Fanciful","Festive","Flavorless","Formulaic","Frumpy","Fancy","Fetching","Flawed","Forthright","Frustrated","Fantastic","Fetid","Flawless","Fortuitous","Frustrating","Far","Feudal","Fleeting","Fortunate","Fulfilled","Faraway","Feverish","Flexible","Forward","Fulfilling","Farcical","Few","Flickering","Foul","Full","Fewer","Flimsy","Fouly","Fully","Farsighted","Fictional","Flippant","Four","Fumbling","Fascinated","Fictitious","Flirtatious","Fourth","Fuming","Fascinating","Fidgeting","Floating","Foxy","Fun","Fascistic","Fidgety","Flooded","Fractional","Functional","Fashionable","Fiendish","Floppy","Fractious","Fundamental","Fast","Faster","Fierce","Floral","Fragile","Fun-loving","Fastest","Fiery","Flowering","Fragmented","Funniest","Fastidious","Fifth","Flowery","Fragrant","Funny","Filmy","Fluent","Frail","Furious","Fat","Filtered","Fluffy","Frank","Furry","Fatal","Filthy","Flushed","Frantic","Furthest","Fateful","Final","Fluttering","Fraternal","Furtive","Fatherly","Financial","Flying","Fraudulent","Fussy","Fathomable","Fine","Foamy","Frayed","Futile","Fathomless","Finicky","Focused","Freakish","Future","Fatigued","Finite","Foggy","Freaky","Futuristic","Faulty","Fireproof","Folded","Freckled","Fuzzy","Favorable","Firm","Following","Free","Fragmentary","Fusile","Fairly","Famed","Flourishing","Fulgent","Forbidden","Forceless","Freaking","Freakish","Frenzied","Frenzy","Fretted","Fretting","Frictional","Frumpish","Fugitive","Funky","Fused","French","Failsafe","Fairish","Fairminded","Fake","Fanged","Farfetched","Faultless"};

  public static final String[] NOUNS_A = {"Aardvark","Abacus","Abbot","Abby","Abductor","Aberrant","Aberration","Abigail","Ablivox","Abode","Abomination","Abracadabra","Abraxas","Absolution","Abundance","Abyss","Accel","Accelarix","Accelera","Accelerator","Acceleron","Accendrix","Access","Accura","Ace","AceofSpades","Acey","Acheron","Achievement","AcidStorm","Acie","Acolyte","Acorn","Acoustic","Acre","Acreage","Active","Actuary","Actuate","Acumen","Acura","Adage","Adagio","Adaline","Adalira","Adalyn","Adaptable","Adapter","Adaptor","Adara","Addison","Addy","Adelaide","Adelina","Adeline","Adelmar","Adelpha","Aden","Adept","Adi","Adira","Adley","Admire","Adonis","Adora","Adorable","Adornment","Adrenaline","Adria","Adroit","Advantech","Advenova","Advent","Adventure","Adversary","Advertiser","Advisor","Aegis","Aegisbot","Aegisx","Aelanor","Aelarian","Aelionix","Aeliora","Aeliorix","Aeloria","Aeloriax","Aelurian","Aeon","Aeonara","Aerilon","Aero","Aerodynix","Aeron","Aeronaut","Aeronautix","Aeronex","Aeronova","AeroWing","Aethalix","Aetharion","Aethelar","Aethelarix","Aethelith","Aethelon","Aether","Aetherial","Aetherite","Aetherius","Aetheron","Aethertech","Aethrial","Aethrion","Aftermath","Aftershock","Agamemnon","Agatha","Agenda","Agent","AgentAlpha","Agentx","Aggie","Aggregate","Aggregator","Aggressor","Agile","AgileTech","Agility","Agnes","Aidan","Aiden","Ailith","Airlift","Alabaster","Alabastermousse","Alacarte","Aladdin","Alamo","Alara","Alaric","Alariel","Alarion","Alba","Alban","Albatross","Alberic","Alberich","Albie","Albion","Album","Alby","Alcadron","Alcatraz","Alchebot","Alchemagix","Alchemis","Alchemisphere","Alchemist","Alchemix","Alchemox","Alchemy","Alcheval","Alchimex","Alchimia","Alchomia","Alchovox","Alcove","Alden","Alder","Aldric","Alec","Alerian","Aleron","Alessandra","Alex","Alfalfa","Alfie","Alfonso","Alfy","AlgaeTech","Algenix","Algeon","Algernon","Algidius","Algo","Algoace","Algoman","AlgoMind","Algonquin","Algor","Algorhythm","Algorider","Algoris","Algorise","Algorithm","Algorithmax","Algorithmia","Algorithmic","Algorithmie","Algorithmite","Algorithmix","Algorium","Algoron","Alibi","Alice","Alight","Alina","Alistair","Alita","Alivara","Aliyah","Alka","Alkahest","Alkemis","Allegory","Allegra","Allocation","Alloy","Allure","Ally","Almanac","Almond","Almondbutter","Almondcookie","Almondcream","Almondfig","Almondine","Almondirish","Almondjoy","Almondlatte","Almondmarsh","Almondmuffin","Almondpaste","Almondpumpkin","Almondshake","Aloe","Alondra","Alonzo","Alora","Alouette","Alouf","Alpaca","Alpha","Alphaberries","Alphabet","Alphabotix","Alphabread","Alphabyte","Alphacake","Alphacauliflower","Alphachip","Alphachrome","Alphadate","Alphadip","Alphadoughnut","Alphaflux","Alphafritter","Alphagelato","Alphaghetti","Alphagrape","Alphagreens","Alphahazelnut","Alphahoney","Alphajam","Alphaleek","Alphalentil","Alphalink","Alphalux","Alphamango","Alphamint","Alphamoon","Alphandroid","Alphanectar","Alphanova","Alphanut","Alphaoatmeal","Alphapeach","Alphapearl","Alphapie","Alphapop","Alphapudding","Alphapulse","Alpharavioli","Alpharoll","Alphaseed","Alphashrimp","Alphasprout","Alphastar","Alphastorm","Alphasundae","Alphatapioca","Alphatart","Alphatofu","Alphaverse","Alphavinegar","Alphawaffle","AlphaWolf","Alphayogurt","Alphy","Alpine","Alric","Altair","Altaira","Altairbot","Altairis","Altairon","Altairus","Altarius","Althaea","Altharian","Altharion","Althea","Altheon","Altherius","Althor","Althorin","Althorix","Altitude","Altitudis","Aluna","Aluvian","Aluviana","Aluvora","Alva","Alvaris","Alvarix","Alvera","Alverix","Alverixis","Alveron","Alvin","Alwin","Amabella","Amadeus","Amadora","Amal","Amalgam","Amalgamation","Amalthea","Amara","Amarante","Amaranth","Amaretto","Amarettocaramel","Amarettofrost","Amarettoglaze","Amarettomango","Amarettomocha","Amarettopancake","Amaryllis","Amaze","Amazix","Amber","Ambient","Ambrose","Ambrosia","Ambush","Amelia","Amelie","Amenity","Amethron","Amethyst","Ametron","Ami","Amiable","Amias","Amigo","Amira","Amity","Ammunition","Amor","Amore","Amorphous","Amos","Amper","Amperaero","Amperage","Amperbot","Ampercore","Ampere","Amperglow","Amperhawk","Amperion","Amperionix","Amperium","Amperius","Ampernova","Amperoid","Amperon","Amperpulse","Ampertron","Ampify","Ample","Amplifier","Amplify","Amplitude","Amulet","Amuletaura","Anachor","Anachronist","Anacorix","Analysis","Analyst","Analytix","Analyzer","Analyzerx","Ananke","Anara","Anarchon","Anarchy","Anaris","Anarithm","Anastasia","Anaxandra","Ancestor","Ancestorix","Ancestry","Anchor","Anchovy","Andi","Andro","Androblitz","Androcore","Androidix","Andromagix","Andromech","Andromeda","Androspace","Androvox","Andy","Anemos","Angel","Angelhair","Angelhairnoodle","Angelic","Angelica","Angeliccookie","Angelus","Angus","Anika","Anima","Animabot","Animaflare","Animaflite","Animaflux","Animaoid","Animapulse","Animatech","Animatrix","Animatron","Animatronic","Animatronix","Animus","Anise","Anisebean","Anisechip","Anisecucumber","Aniseoat","Aniseroast","Ankh","Ankhara","Annabelle","Annalise","Annie","Annihilator","Annuity","Anoint","Anomalix","Anomaly","Anomalyte","Anorix","Anouk","Anova","Anovara","Anovasion","Anovatech","Anovoyager","Ansel","Anselm","Ansgar","Antagonist","Antares","Antarianix","Anteater","Antenna","Anthea","Anthem","Antidote","Antiquus","Antithesis","Antler","Antonia","Antonina","Antrix","Anubis","Anvil","Anvilix","Anya","Apache","Aperture","Aperturex","Apex","Apexbot","Apexpredator","ApexPredator","Apexstar","ApexTech","Apextron","Apextronix","Apogee","Apogeebot","ApogeeX","Apollo","Apollonia","Apollonius","Apollostar","Apollyon","Apothech","Apothechime","Apotheosia","Apotheosis","App","Appaloosa","Apparatus","Apparition","Appengine","Applause","Apple","Appleberry","Applecaramel","Appleicicle","Applejicama","Appleketchup","Applekiwi","Appleslice","Applestrudel","Applevanilla","Application","Applicator","Appo","Appraisal","Apprehender","Apprehension","Appy","Apricot","Apricotcider","Apricotcranberry","Apricotjelly","Apricotquiche","Apricotslice","Aqua","Aquabot","Aquabotix","Aquabreeze","Aquacraft","Aquadream","Aquafin","Aquafuture","Aqualink","Aqualuna","Aquamarine","Aquanaut","Aquandra","Aquanetix","Aquanex","Aquanox","Aquaphor","Aquarianix","Aquarion","Aquarium","Aquarius","Aquariux","Aquarobot","Aquastral","Aquatix","Aquavale","Aquavoyage","Aquawave","Aquila","Aquiline","Aquilis","Aquilith","Aquillar","Arabella","Arabelle","Arabesque","Arachnid","Aramis","Arbiter","Arbitrator","Arc","Arcadia","Arcadium","Arcadius","Arcadron","Arcadus","Arcanaut","Arcanavision","Arcane","Arcaneon","Arcaneutron","Arcanex","Arcanis","Arcanix","Arcanoid","Arcanum","Archangel","Archelon","Archeon","Archer","Archetype","Archfiend","Archie","Archimage","Archinalis","Archinator","Archipelago","Archive","Archon","Archonix","Archontis","Archway","Arconix","Arcturan","Arcturus","Ardent","Ares","Argent","Argenta","Argentia","Argentis","Argentix","Argentum","Argentus","Argo","Argon","Argonaut","Argonauta","Argonix","Argonova","Argus","Ari","Aria","Ariadne","Ariel","Arion","Arithmetix","Arlo","Armada","Armor","Armory","Arquebus","Arquenix","Array","ArrayBot","Arrow","Arsenic","Arsonist","Artech","Artemis","Artichoke","Artie","Artifact","Artifice","Artisan","Arty","Aruba","Arugula","Arvadion","Arvadis","Arvadon","Arvador","Arvadron","Arvaelor","Arvandar","Arvandis","Arvandor","Arwen","Ascend","Ascendancy","Ascent","ASCII","Asha","Ashbel","Ashen","Asher","Ashlyn","Ashlynn","Ashton","Ashwyn","Ashy","Asimovix","Asparagus","Aspect","Aspen","Aspire","Aspyron","Assassin","Assembly","Asset","Association","Astara","Astelar","Aster","Asterion","Asterix","Astoria","Astorix","Astound","Astra","Astrabird","Astrablitz","Astrabotix","Astracruiser","Astradive","Astradream","Astradroid","Astraea","Astraeon","Astraeus","Astrafire","Astraflame","Astraflare","Astraflux","Astraforce","Astraforge","Astragaze","Astraglide","Astral","Astraleon","Astralift","Astralite","Astralium","Astralix","Astralknight","Astralon","Astralume","Astralumina","Astraluna","Astralux","Astralynx","Astramark","Astramorph","Astranex","Astranox","Astraquark","Astrarium","Astravision","Astray","Astrid","Astrionor","Astrionyx","Astro","Astrobane","Astrobionix","Astrobot","Astrobotic","Astrobreeze","Astrodawn","Astrodynix","Astroflare","Astroforge","Astrofusion","Astrogaze","Astroglo","Astrogrimo","AstroKnight","Astrolight","Astrolith","Astrologie","Astrolume","Astrolux","Astrolynx","Astrolyte","Astromagus","Astromarx","Astromatrix","Astromax","Astromech","Astromera","Astromorph","Astromyst","Astron","Astronaut","Astroneo","Astronix","Astronomer","Astroprobe","Astropulse","Astroquark","Astroquest","Astrorise","Astrostrive","Astrotrix","Astrovibe","Astrylar","Astrylis","Astrylite","Astrylith","Astute","Asylum","Atalanta","Athame","Athanor","Athena","Athlete","Athos","Atlas","Atlasbot","Atlasgaze","Atlasnova","Atlasphere","Atlasynth","Atom","Atomatrix","Atomic","Atomica","Atomictech","Atomika","Atomion","Atomix","Atomizer","Atrium","Atronix","Atticus","Attire","Auberon","Aubree","Auden","Audible","Audience","Auggie","Augie","Augment","Augmenta","Augur","Augurion","Augury","August","Augustus","Aura","Auranix","Auraphor","Aurelia","Aurelius","Auricron","Aurion","Aurora","Aurorabird","Auroral","Auroralis","AuroraPrime","AuroraTech","Aurorion","Aurorium","Aurorix","Autie","Autobot","Autocrat","Automagix","Automagus","Automation","Automatrix","Automatron","Automorph","Autonomy","Autumn","Ava","Avail","Avalanche","Avalanor","Avaleria","Avaleth","Avalith","Avalithor","Avalon","Avalonix","Avalore","Avaluna","Avandrix","Avanor","Avante","Avantech","Avatar","Avelina","Aveline","Avenger","Avenue","Avery","Avi","Avian","Aviana","Avianaut","Aviantron","Aviator","Aviatora","Aviatorix","Aviatrix","Avidonix","Avidra","Avidracon","Avidron","Avion","Avionics","Aviorbit","Avo","Avocado","Avocadochili","Avocadochop","Avocadoqueso","Avocadoquinoa","Avocadozucchini","Avon","Avowal","Awetech","Axel","Axen","Axi","Axie","Axiobright","Axiocraft","Axiocruiser","Axiodynix","Axioforge","Axiogear","Axiogenesis","Axioglide","Axioluxe","Axiom","Axiomachine","Axiomalia","Axiomancer","Axiomatic","Axiomatrix","Axiomech","Axiomis","Axiomodule","Axiomoon","Axiomos","Axiomus","Axion","Axionaut","Axionix","Axioplasm","Axiopulse","Axiorythm","Axiotech","Axiotron","Axiowave","Axiowind","Axiowizard","Axis","Axle","Axon","Axonetics","Ayla","Azalea","Azrael","Aztec","Azul","Azuline","Azulith","Azura","Azuraflame","Azuralith","Azure","Azurech","Azurell","Azureon","Azurian","Azurine","Azurion","Azurite","Azuritech","Appleblossom","Angelicat","Adventureon","Apricotwink","Amazeball","Abracharm","Acornella","Auroraflare","Alphabug","Autumnleaf","Adorablepaw","Astralbeam","Amazinglyx","Angelwhisper","Amberwing","Artisticpaws","Allsparkle","Angelicdream","Aquaflutter","Adorablepuff","Airydoodle","Aromabreeze","Admireables","Aurorafluff","Angelglitter","Apricotsprinkle","Amazepet","Andesky","Artisticwhirl","Astrobunny","Amplejoy","Aquaquill","Autumnwhisper","Affectionatepaw","Angelicgaze","Amiablepaws","Aetherfluff","Avidspark","Auroraflame","Angelicfrost","Angelicadorbs","Adventurepuff","Acousticpurr","Adorablefins","Apricotwhisk","Alluringwhirl","Angelicsong","Amiablepurr","Airyblossom","Adoreablewings"};

  public static final String[] NOUNS_B = {"Babblesnug","Babblo","Baboon","Babushka","Baby","Babybear","Babycakes","Babydoll","Babyface","Babygirl","Babykins","Babysitter","Backflip","Backlash","Backpack","Backspace","Backspin","Backstage","Backyard","Badger","Badlands","Baelor","Baelorath","Baeloria","Baelorian","Baelorin","Baelorion","Baelorix","Baff","Bagel","Baggage","Baggy","Bagheera","Bagira","Baguette","Bagus","Bailey","Baking","Balaclava","Balcony","Balder","Baldric","Ballad","Ballerina","Ballet","Ballgown","Balloon","Ballpark","Ballpoint","Ballroom","Balmatech","Balmatrix","Balmatron","Balmy","Baloo","Balsam","Balthazar","Balustrade","Bambi","Bambino","Bamboo","Banana","Bananarama","Bandage","Bandana","Bandanna","Bandicoot","Bandit","Banditry","Baneblade","Baneclaw","Bangle","Banishment","Banister","Banjo","Banker","Banknote","Banquet","Banshee","Bansheevil","Barael","Barbarian","Barbecue","Barcode","Barcoder","Baritone","Barkley","Barnacle","Barnyard","Baron","BaronDarkfire","BaronDarkstorm","BaronDrakon","Baroness","BaronessAbyss","BaronessHex","BaronessMalice","BaronessMorgana","BaronessMorgara","BaronessNocturna","BaronessNyx","BaronessSanguine","BaronessSerpent","BaronessShadow","BaronessTempest","BaronessVenom","BaronessViper","BaronGrimscar","BaronInferno","BaronInfernus","BaronMalevolence","BaronMalice","BaronRagnor","BaronSable","BaronSorrow","BaronVile","BaronVoid","BaronVortex","Barray","Barricade","Bartender","Barter","Baseball","Bash","Bashful","Basicbase","Basicbeam","Basicbind","Basicblend","Basicblitz","Basicblossom","Basicboost","Basicbubble","Basicbyte","Basiccache","Basiccheck","Basiccircuit","Basiccode","Basiccommand","Basicconnect","Basiccontrol","Basiccore","Basiccraft","Basiccurve","Basicdata","Basicdrive","Basicdynamics","Basicecho","Basicelement","Basicengine","Basicflow","Basicflux","Basicfocus","Basicforce","Basicforge","Basicfusion","Basicgrid","Basichaven","Basichelix","Basichub","Basichype","Basicimpact","Basicinfinity","Basicinsight","Basicintegrate","Basicinteract","Basicinterface","Basicjourney","Basickinetic","Basicknight","Basiclegacy","Basiclight","Basiclink","Basiclumen","Basicly","Basil","Basilica","Basilisk","Bask","Basketball","Bassinet","Bassoon","Bastille","Bastion","Battleaxe","Bayberry","Bayfield","Bayleaf","Baymax","Bayou","Bayshore","Baystream","Baywatch","Beach","Beachball","Beacon","Beaconbot","Beaconite","Beadboard","Beads","Beadwork","Beamer","Beamtron","Beanie","Beanstalk","Beany","Bear","Bearclaw","Bearcub","BearHug","Bearpaw","Bearskin","Beasley","Beast","Beastmaster","Beatnik","Beatrix","Beau","Beauty","Beaver","Bebe","Bebedazzle","Bebedoodle","Bebelle","Bebitiny","Bebito","Bebitwinkle","Bebop","Bebopkins","Beboplet","Beechwood","Beekeeper","Beelight","Beelighter","Beeline","Beelove","Beelovebug","Beelovely","Beemancer","Beematrix","Beemender","BeepBeep","Beepbox","BeepBuddy","Beeps","Beepster","Beeswax","Beforebranch","Befriend","Befuddle","Behemoth","Beholden","Belarion","Belenus","Belfire","Bella","Bellacourt","Belladonna","Belladriel","Belladrix","Bellagrim","Bellamira","Bellamy","Bellamyra","Bellamyre","Bellaria","Bellasara","Bellasha","Bellatrix","Bellavera","Bellavita","Bellavox","Bellbottom","Bellboy","Belle","Belleric","Bellerophon","Bellerose","Bellezza","Bellicent","Bellicia","Bellicose","Bellona","Bellow","Bellwether","Beloop","Belovabelle","Beloved","Belovedeary","Belovedkins","Belovedroid","Belphoebe","Beluga","Beluna","Belvedere","Belvedrina","Belvidere","Benevolent","Beorn","Beowulf","Beowyn","Bernard","Berry","Berrybush","Berrystone","Beryllium","Beryllyn","Betrayer","Bevelyn","Bewilder","Bewitched","Bewitchery","Bezel","Bianca","Bibblesnicker","Bibblesnook","Bibi","Bibliophile","Bicheck","Biconnect","Bif","Biff","Biffix","Bifire","Biflow","Bifocal","Bifocus","Bifold","Biforce","Bigfoot","Biglitch","BigMama","Bigwig","Bilateral","Billboard","Billow","Billy","BillytheKid","Binarya","Binaryte","Bincline","Bind","Binflux","Bingleberry","Binklemoon","Binklesnuggle","Binkleton","Binkletwirl","Binksy","Binky","Binkyblossom","Binkyboo","Binx","Bioflux","Bioluminescence","Bionova","Biowave","Bipoll","Bippity","Bippityboo","Bippitybreeze","Birchbark","Birchbreeze","Birchgrove","Birchleaf","Birchtree","Birchwood","Birdie","Birdseye","Birdsong","Birdwing","Birender","Birthmark","Biscotti","Biscuit","Bison","Bistash","Bitarray","Bitbeam","Bitblaze","Bitblitz","Bitbot","Bitbreak","Bitbyte","Bitch","Bitchip","Bitchurn","Bitclimb","Bitcode","Bitcomet","Bitcrave","Bitcraze","Bitcrunch","Bitflux","Bitfold","Bitfusion","Bitgenix","Bitgizmo","Bitglow","Bitgoto","Bitgrid","Bithive","Bithub","Bitif","Bitlet","Bitlink","Bitlogic","Bitlume","Bitmate","Bitmatics","Bitmerger","Bitmorph","Bitmux","Bitnano","Bitnix","Bitnova","Bitnudge","Bitoracle","Bitover","Bitpulse","Bitquake","Bitquantum","Bitquasar","Bitquest","Bitrider","Bitroar","Bitrobo","Bitrover","Bitspark","Bitstellar","Bitster","Bitstorm","Bitstream","Bitstreamer","Bitstrike","Bitstring","Bitsy","Bittersweet","Bitty","Bitverse","Bitwave","Bitwhiz","Bitzenith","Bitzephyr","Bitzy","Bivisit","Biwait","Bixby","Bixie","Bixiwiggle","Bizzaroo","Bizzionary","Bizzisphere","Bizzleap","Blabberdoodle","Blabbermind","Blabblequip","Blabblesnap","Blabblex","Blabbster","Blackberry","Blackbird","Blackboard","Blackclaw","Blackfang","Blackfire","Blackhawk","Blackheart","Blackhearted","Blackhowl","Blackjack","Blacklist","Blackmail","Blackout","Blackraven","Blackscar","Blackscarab","Blackshade","Blackshadow","Blackskull","Blacksmith","Blacksmoke","Blackspire","Blackstone","Blackstrike","Blackthistle","Blackthorn","Blackthorne","Blackvenom","Blackwing","Blackwood","Blackwraith","Bladebane","Bladeclaw","Bladestorm","Bladewind","Bladewraith","Blaine","Blaise","Blarney","Blask","Blaster","Blatch","Blaze","Blazebane","BlazeCore","Blazefang","Blazefern","Blazefire","Blazefist","Blazeheart","Blazeleaf","Blazeon","Bleakheart","Blender","Blert","Blessibot","Blessidrone","Blibber","Blibberblast","Blibberburst","Blibberbuzz","Blibberbyte","Blibberdash","Blibberflame","Blibberloop","Blibberscope","Blibbertech","Blibberwave","Blibberzone","Blick","Blide","Blidge","Blidrive","Bliflow","Blightcaster","Blightedheart","BlightedOne","Blimp","Blinexus","Blink","Blinkbind","Blinkloop","Blip","Blipback","Blipbit","Blipblesnuggle","Blipboost","Blipjump","Bliplease","Bliploop","Blipper","Blippity","Blipster","Blipsterloop","Blipswitch","Blipvent","Blipzoom","Blipzor","Blirate","Blirelay","Blissbloom","Blissbot","Blissful","Blissfulite","Blisshealer","Blissomatic","Blisstech","Blister","Blitch","Blitide","Blitwist","Blitzen","Blivolve","Blizzard","Bloat","Bloc","Blockchain","Blockflick","Blockify","Blockload","Blocode","Blocrash","Bloff","Bloke","Bloodfang","Bloodfist","Bloodflame","Bloodhound","Bloodlust","Bloodmoon","Bloodrage","Bloodraven","Bloodscourge","Bloodseeker","Bloodseer","Bloodsiren","Bloodthorn","Bloom","Bloombeacon","Bloomcaster","Bloomdroid","Bloomspark","Blooparoo","Bloopster","Blort","Blossom","Blossomdancer","Blossomdroid","Blossomfizz","Blossomhill","Blossommancer","Blossomwind","Bludge","Bludger","Blue","Bluebeard","Bluebell","Blueberry","Bluebird","Bluebonnet","Bluefin","Bluefish","Bluegrass","Bluehaven","Blueheron","Bluejay","Bluelake","Bluemist","Bluepeak","Blueprint","Blueridge","Bluestar","Bluestone","Bluetide","Bluff","Bluffside","Blumblebee","Blunder","Blush","Bluster","Blyde","Blythe","Boarding","Boardwalk","Boathouse","Boatyard","Bobsled","Bobsleigh","Bodyguard","Boflux","Boggle","Bogglewiz","Bogland","Bogwood","Boisterous","Bojangles","Bolish","Bologna","Boloop","Bolt","Boltex","Boltie","Boltivate","Boltster","Boltware","Bombshell","Bonanza","Bonbon","Bonbonette","Bonbonita","Bonebreaker","Bonecrusher","Bonfire","Bongo","Bonkers","Bonnyvale","Bonsai","Bontoggle","Bonzai","Bonzoodle","BooBear","Booblebee","Booboo","BooBoo","Boogle","Bookaroo","Bookmark","Bookshelf","Bookworm","Boolify","Boomer","Boomerang","Boop","Boopburst","Boopcode","Boopdrive","Boopfind","Boopflare","Boopquery","Boopserve","Bootlace","Bootup","Booty","Boparse","BoPeep","Bopipe","Boploop","Boplug","Bopose","Boppity","Bopress","Bopster","Bosh","Boss","Botanical","Botanist","Boto","Botoggle","Botrack","Botransit","Botron","Botshift","Bottleneck","Bottlenose","Botzy","Boulder","Boulderrock","Boulderstone","Boulderwood","Bountiful","Bounty","Bourbon","Bovine","Bowling","Boxcar","Boxer","Boxwood","Brack","Bracken","Braddock","Bragging","Braid","Braille","Brainbeam","Brainbitsy","Brainblast","Brainbles","Brainblitz","Brainbop","Brainbreeze","Brainbubble","Brainburst","Brainbuzz","Brainchirp","Braindazzle","Brainfizz","Brainflame","Brainfluence","Brainflux","Brainfunk","Brainjam","Brainliterate","Brainlume","Brainlusion","Brainmunch","Brainoink","Brainooble","Brainoodle","Brainoquest","Brainorama","Brainplop","Brainpuff","Brainpulse","Brainpuzzle","Brainquake","Brainquark","Brainquirk","Brainriddle","Brainverse","Brainvortex","Brainwave","Brainwhirl","Brainwhiz","Brainwiz","Brainzest","Brainzoom","Bramble","Bramblebrook","Bramblesong","Bramblethorn","Bramblewood","Bramwell","Branch","Branchify","Brando","Brandy","Branwen","Brasserie","Bratwurst","Bravado","Braveheart","Braveoak","Bravery","Bravestone","Bravo","Brawny","Brazen","Breakfast","Breakneck","Breeze","Breezefixer","Breezefluff","Breezelet","Breezella","Breezy","Breezybelle","Breezydoodle","Breezysnuggle","Briarleaf","Briarrose","Briarsong","Briarthorn","Briartree","Briarwood","Bricklayer","Briefcase","Brigade","Brigadier","Brigand","BrightEyes","Brightstar","Brimclaw","Brimstalker","Brimstone","Brine","Brint","Brioche","Brisingr","Brisk","Brisket","Briskwater","Bristle","Brittle","Brizzle","Broadway","Brocade","Broccoli","Bronco","Brontes","Brontide","Brookfield","Brookhaven","Brooklet","Brooklyn","Brookridge","Brookside","Brooksong","Brookstone","Brookview","Broom","Broomstick","Brottle","Brownie","BrownSugar","Browserella","Browserette","Browserkin","Bruff","Brulee","Brumble","Brunch","Bruno","Brush","Brutalbane","Brutalclaw","Brutalizer","Bruteclaw","Brutethorn","Brynhild","Brynhilda","Brynhilde","Brynhildr","Brystan","Bryston","Bubba","Bubble","Bubblebliss","Bubblegum","Bubblematic","Bubblemender","Bubblemind","Bubblenest","Bubblenetic","Bubblenex","Bubblenova","Bubbles","Bubblesnuggle","Bubblewrap","Bubblorama","Bubbly","Bubblyblossom","Bubblywhisk","Bubby","Bubliterate","Bubsy","Buccaneer","Buckaroo","Buckeye","Buckshot","Buckwheat","Buddy","Buddyheal","Budge","Buff","Buffalo","Buffer","Bufferina","Buffet","Bugatti","Buggie","Buggle","Buggy","Bugle","Bugleap","Bugo","Bulldozer","Bullet","Bulletproof","BulletTrain","Bullfinch","Bullfrog","Bullhorn","Bullmastiff","Bullpen","Bullseye","Bullwhip","Bumble","Bumblebalm","Bumblebeam","Bumblebee","Bumblebop","Bumblebuns","Bumbleflutter","Bumblefoot","Bumblegiggle","Bumbleglimmer","Bumblepaws","Bumbleroo","Bumbles","Bumblesnicker","Bumblesprout","Bumbletwinkle","Bumblewhirl","Bumblewhisk","Bumblewinks","Bumblewuzzle","Bump","Bumper","Bumpkin","Bun","BunBun","Bungee","Bunkbed","Bunker","Bunny","Bunnykins","Burch","Burden","Busboy","Bushel","Bushwhisper","Bushy","Busker","Butterball","Butterbean","Buttercream","Buttercup","Butterfinger","Butterfluff","Butterfly","Buttermilk","Butterscotch","Butterwing","Buttonette","Buttons","Buttonwood","Buttony","Buzoodle","Buzzard","Buzzbot","Buzzleaf","Buzzorama","Buzzy","Buzzybop","Bygone","Bypass","Byssus","Bytebeam","Byteblade","Byteblaze","Byteblitz","Bytebreeze","Byteburst","Bytebyte","Bytecaster","Bytecheck","Bytecipher","Bytecircuit","Byteclipse","Byteclix","Bytecore","Bytecrafter","Bytecrunch","Bytedrive","Bytefactor","Byteflame","Byteflare","ByteFlare","Byteflect","Byteflow","Byteflux","Bytefrenzy","Bytefuel"};

  public static final String[] NOUNS_D = {"Daal","Dab","Dabble","Daedalus","Dael","Daelan","Daelia","Daelin","Daemon","Daenerys","Daffodil","Daffy","Dagger","Dagmar","Daguerreotype","Dagwood","Dahi","Dahlia","Daija","Daikon","Daintydazzle","Daintydoodle","Daintydream","Daintytwirl","Daintywhirl","Daiquiri","Daiquiriglass","Daire","Daisies","Daisy","Daisychime","Daisycove","Daisydew","Daisydoodle","Daisydream","DaisyDuke","Daisyglen","Daisylake","DaisyMae","Daisysong","Dajah","Dakota","Dal","Dalary","Dalia","Daliah","Dalila","Dallan","Dallas","Dallin","Dalmatian","Dalton","Daltrey","Damara","Damaran","Damarion","Damaris","Damia","Damion","Damon","Dampness","Damselfly","Danaé","Dance","Dandelar","Dandelight","Dandelion","DandelionDance","DandelionFluff","DandelionWishes","Dandelume","Dandeluna","Dandelush","Dandelust","Dandelux","Dandydoodle","Dandydragon","Dandylion","Dango","Dania","Danica","Daniel","Daniele","Daniella","Danielle","Danika","Danish","Dante","Danté","Danube","Daphne","Dapple","Dapplebrook","Dappledawn","Dappledew","DappledShade","Dapplemist","Dapplemoon","Dapplespring","Dappletide","Daquan","Dara","Darby","Darcy","Daredevil","Daren","Darian","Dariana","Dariel","Darien","Daring","Daringdoodle","Darkenergy","Darkenergyprobe","Darkexpanse","Darkhalo","Darkhorizon","Darkling","Darkmatter","Darkmatterparticles","Darkmatterresearch","Darkmoon","Darknebula","Darkorbit","Darksky","Darkskyline","Darkskyobservatory","Darkspell","Darla","Darlene","Darlin","Darnell","Darrell","Darren","Dartboard","Darts","Darwin","Daryn","Dash","Dasha","Dashboard","Dashboardcam","Dasher","Dashscript","Dashwood","Data","Dataarchive","Databank","Database","Databolt","Databot","Databurst","Databyte","Datacache","Datacraze","Datacrunch","Datadash","Datadoodle","Datadynamo","Dataflow","Dataforce","Dataglide","Datahive","Dataline","Datalink","DataLink","Datalogic","Datamatrix","Datamecha","Dataminer","Datamingle","Dataninja","Datapioneer","Dataprocessor","Datapulse","Dataquest","Datarelay","Datarover","Datasentry","Dataspark","Dataspire","Datastream","Datatech","Datatransmission","Datawave","Dataxpress","Date","Datsun","Daughters","Dauphinoise","David","Davin","Davina","Davinci","Davion","Dawn","Dawnbreaker","Dawning","Dawnlight","Dawnmist","Dawnshade","Dawnstar","Dax","Daxton","Dayana","Dayanara","Daybreak","Daybreakstar","Daydew","Daydream","Daydreamer","Daylight","Daylily","Daylumin","Dayna","Dayrider","Daysha","Daystar","Daytona","Dazzle","Dazzleberry","Dazzlebop","Dazzlebubble","Dazzlecorn","Dazzleflip","Dazzlefluff","Dazzleflutter","Dazzlefrost","Dazzleglow","Dazzlehop","Dazzlelark","Dazzlelily","Dazzlement","Dazzlemist","Dazzlepuff","Dazzleray","Dazzlesong","Dazzlestone","Dazzleton","Dazzletwist","Dazzlewhirl","Dazzling","Deadshot","Dealer","Dean","Deandre","Deangelo","Deanna","Deborah","Debrisfield","Debugbeam","Debugblitz","Debugdroid","Debugflare","Debuggen","Debuggenius","Debugglitch","Debugguru","Debughaven","Debugmatrix","Debugninja","Debugquest","Debugradar","Debugrover","Debugspark","Debugtron","Debutante","Decade","Decadence","Decal","Decency","Decipher","Deck","Declan","Declaration","Decoction","Decoder","Decorum","Decrescendo","Dedication","Deductible","DeeDee","Deepblue","Deepcosmos","Deepexplorer","Deepfield","Deepfieldtelescope","Deepfreeze","Deepgalaxy","Deepimpact","Deepmind","Deepprobe","Deepscan","Deepspace","Deepspacenetwork","Deepstar","Deepuniverse","Deepvoid","Deer","Defender","Defendx","Defense","Defiance","Deficit","Deflector","Deforestation","Deimos","Deimosbase","Deimoscolony","Deimosoutpost","Deimosstation","Deity","Deja","Delancey","Delaney","Delanie","Delectable","Delectation","Delena","Deli","Delia","Delicacy","Delicadeza","Delicado","Delicatebloom","Delicatebreeze","Delicatessen","Delicavio","Delight","Delightbloom","Delightedonut","Delightelope","Delightfall","Delightfire","Delightflare","Delightfulbite","Delightfulness","Delighticorn","Delightshade","Delilah","Delineation","Delivery","Della","Delmare","Delmer","Delmonico","Delores","Delphi","Delphin","Delphina","Delphinium","Delroy","Delsin","Deltaexploration","Deltagalaxy","Deltaquadrant","Deltaray","Deltarocket","Deltastarship","Deltawave","Deltronic","Delusion","Deluvia","Deluxia","Delwin","Demarcation","Demarcus","Demarius","Demeanor","Demelza","Demeter","Demetri","Demetrius","Demography","Demolition","Demolitionderby","Demureness","Den","Denial","Denim","Denise","Denizen","Denny","Denouement","Dentist","Denunciation","Deon","Deploydash","Derivation","Dervish","Dervla","Descentmodule","Desdemona","Desert","DesertRose","Desideratum","Desiderio","Design","Designdrift","Designer","Desire","Desk","Desmond","Desolation","Despina","Dessert","Dessertplate","Destiny","Destruction","Detective","Detector","Devan","Devastator","Devbeam","Devbolt","Devbrew","Devcipher","Devcoder","Devcraft","Devdash","Devdebug","Devflow","Devflux","Devfusion","Devgiz","Devgizmo","Devhacker","Devhaven","Deviance","Deviation","Deviled","Devjunction","Devlin","Devmatrix","Devmind","Devmingle","Devnex","Devnode","Devnucleus","Devona","Devonte","Devopsify","Devora","Devotion","Devotional","Devourer","Devouring","Devpixel","Devpulse","Devquark","Devsavvy","Devscribe","Devscript","Devsense","Devsprint","Devsprite","Devsync","Devvertex","Devvortex","Devwarp","Devwizard","Devyn","Dewberry","Dewdrop","Dewey","Dewfall","Dewflower","Dewfrost","Dewshade","Dewshine","Dewspark","Dewstar","Dewtide","Dewwhisper","Dewydream","Dewyglade","Dewylight","Dewysong","Dewysun","Dexter","Dexterity","Diadem","Diagonaltire","Diagram","Dialect","Dialogue","Diamara","Diamatrix","Diamond","Diamondash","Diamondelle","Diamondflame","Diamondgale","Diamondleaf","Diamondmist","Diamondsky","Diamondwhirl","Diamoon","Diana","Dianna","Dianne","Diantha","Diary","Dice","Dicey","Dictator","Dictionary","Dido","Dierdre","Diesel","Dieselengine","Differential","Digby","Digest","Digibyte","Digicircuit","DigiCom","Digicore","Digicraft","Digiforge","Digiguard","Digimatrix","Digiplex","Digipulse","Digirover","Digistar","Digistream","Digitalcode","Digitalcosmos","Digitalcraft","Digitalcrafter","Digitaldive","Digitaldrift","Digitalflare","Digitalforge","Digitalfrontier","Digitalhorizon","Digitalis","Digitalobservatory","Digitalpulse","Digitalrover","Digitalsatellite","Digitalstarship","Digitaltelescope","Digitech","Digitron","DigiWave","Digixplorer","Dijon","Diligence","Dill","Dillinger","Dillpickle","Dillydally","Dilys","Dime","Dimensionalshift","Dimensionportal","Dimensionwarp","Dimple","Dimplebop","Dimpleflutter","Dimpleglen","Dimplehop","Dimpleleaf","Dimples","Dimplevale","Dimplew","Dimplewave","Dimplewhisk","Dimplewink","Dimsum","Dina","Dinermenu","Dingbat","Dingle","Dinglebat","Dingleberry","Dinglebop","Dingledorf","Dingledork","Dinglefairy","Dingleflutter","Dinglehopper","Dinglewhirl","Dinglewhisk","Dinglewhiz","Dinky","Dinner","Dinnertable","Dino","Dinosaur","Dionne","Dionysus","Dior","Dip","Diploma","Diplomacy","Diplomat","Dipper","Director","Directory","Directorydive","Dirtbike","Dirttrack","Disc","Discard","Discbrakes","Discernment","Disciple","Discipline","Disclosure","Disco","Discography","Discourse","Discovery","Discoverymission","Discoveryprobe","Discoverystation","Discoveryteam","Discretion","Disguise","Dishware","Disk","Diskette","Dismay","Dispatch","Disposition","Disruption","Distantbeacon","Distantcomet","Distantexoplanet","Distantgalaxy","Distantmoon","Distantsolarsystem","Distantsun","Distantsystem","Distantworld","Distinction","Diva","Divan","Dive","Diver","Diversion","Diversity","Dividend","Divina","Divinara","Divination","Divinea","Divinedust","Diviner","Divinestar","Divinity","Division","Dixie","DixieBelle","Dizzlemoon","Dizzleroot","Dizzy","Dizzybop","Dizzybounce","Dizzybunny","Dizzytwist","Dizzywhirl","Dizzywizzle","Dobby","Docility","Dock","Dockbot","Dockerdash","Dockmaster","Dockxplorer","Dockxpress","Dockyard","Doctor","Doctrine","Document","Dodge","Doe","Dogfight","Dogwood","Dolce","Doldrums","Doll","Dollar","Dollhouse","Dolly","DollyParton","Dolores","Dolphin","Domain","Domaindasher","Dome","Domecity","Domenic","Domenica","Domeshield","Dominic","Dominique","Domino","Dominoes","Donatella","Donatello","Donation","Doner","Donnelly","Donnie","Donovan","Donut","Donuts","Donutspare","Doodle","Doodlebounce","Doodlebug","Doodlewhirl","Doodlewhisk","Doohickey","Doolittle","Doom","Doomsday","Door","Doppelganger","Doppelgänger","Dora","Dorado","DoratheExplorer","Dorian","Doriana","Dorinda","Doris","Dorito","Dorkface","Dormitory","Dosa","Dottie","Dotty","Doug","Dough","Douglas","Dove","Dovetail","Dovetrill","Dovewillow","Dovewind","Dovewing","Downfall","Downforce","Downhill","Downpour","Downshifting","Dozer","Draco","Dracocluster","Dracoconstellation","Draconis","Dracula","Draft","Drafting","Dragcar","Dragchute","Dragcoefficient","Dragger","Draglink","Dragon","Dragonfire","Dragonfly","Dragonfruit","DragonWing","Dragrace","Dragracing","Dragslicks","Dragster","Dragsterengine","Dragstrip","Dragway","Drake","Dramatics","Drape","Drapery","Draven","Drawer","Dream","Dreama","Dreamblaze","Dreambot","Dreambound","Dreambreeze","Dreamcast","Dreamcatcher","Dreamchaser","Dreamcraft","Dreamdance","Dreamdew","Dreamdroid","Dreamer","Dreamglade","Dreamglow","Dreamhaven","Dreamland","Dreamlark","Dreamlily","Dreamlume","Dreamquill","Dreamrover","Dreamscape","Dreamscorch","Dreamseeker","Dreamshade","Dreamshadow","Dreamshore","Dreamsmith","Dreamspell","Dreamspindle","Dreamspire","Dreamster","Dreamstitch","Dreamstone","Dreamstorm","Dreamstream","Dreamtide","Dreamwalker","Dreamwater","Dreamwave","Dreamweaver","Dreamweft","Dreamwhirl","Dreamwhisper","Dreamwisp","Dreamwonder","Dreamybop","Dreamycorn","Dreamydazzle","Dreamydoodle","Dreamyfrost","Dreamyspark","Dreamytwist","Dreamywhirl","Dreamywhisk","Dresden","Dress","Dressing","Drew","Drift","Driftbloom","Driftbot","Driftcar","Driftcompetition","Drifter","Driftevent","Driftglen","Drifting","Driftking","Driftshore","Driftsong","Driftspark","Driftstar","Driftstone","Drifttech","Drifttires","Driftwhirl","Driftwhisper","Driftwisp","Driftwood","Driftwoodtable","Driftx","Driftxplorer","Drinkcoaster","Drive","Drivebot","Drivein","Driver","Driverdaemon","Driveshaft","Drivester","Drivethrough","Drivethru","Drivetrain","Drivewave","Driveway","Drizzle","Drizzlebeam","Drizzlebean","Drizzlebloom","Drizzlebreeze","Drizzlecake","Drizzlefall","Drizzlemoon","Drizzlepool","Drizzlesong","Drizzlewood","Drogo","Droid","Droiddev","Drone","Dronexplorer","Dronexpress","Druid","Drum","Drumbeat","Drummer","Drumroll","Drumstick","Drunk","Drunkard","Drunken","Drusilla","Drusus","Dryrub","Drystan","Dualclutch","Dualcore","Dualexhaust","Dualstar","Duchess","Duck","Duckie","Duckling","Duct","Duel","Duffy","Dufus","Dug","Dugout","Duke","Dulce","Dulcinea","Dulse","Dumbledore","Dumbletush","Dumpling","Dumplingbowl","Duncan","Dunce","Dunderhead","Dune","Dunebuggy","Duneplanet","Dungeon","Dunker","Duodisc","Duoflex","Duogear","Duogem","Duogrip","Duolight","Duolounge","Duopark","Duoride","Duorun","Duosmooth","Duostamp","Duostyle","Duotour","Duotrek","Duotrend","Duress","Durian","Dusk","Duskbloom","Duskbreeze","Duskcove","Duskcreek","Duskfall","Duskfern","Duskflame","Duskglow","Dusklake","Dusklight","Duskmeadow","Duskmere","Duskmist","Duskmistral","Duskmyst","Duskrider","Dusktide","Dusktwist","Duskwake","Duskward","Duskwarden","Duskwave","Duskwood","Dust","Dustbunny","Dustcloud","Dustfall","Dustpan","Duststorm","Dustwing","Dusty","Dustyasteroid","Dustyplanet","Dustysurface","Dustyterrain","Dustywisp","Duval","Duvet","Dwarfgalaxy","Dwarfplanet","Dwarfstar","Dwayne","Dwelling","Dwight","Dylan","Dynabot","Dynabyte","Dynacircuit","Dynacomet","DynaCore","Dynacraft","Dynadrive","Dynaforce","Dynaguard","Dynalink","Dynamecha","Dynamics","Dynamo","Dynamox","Dynanova","Dynaplex","Dynapulse","Dynarider","Dynarover","Dynaspace"};

  public static final String[] NOUNS_F = {"Fabio","Fabiola","Fable","Fablemoon","Fabric","Fabulous","Facade","Face","Facet","Facility","Facilitymanagement","Facsimile","Factory","Faculty","Faelan","Faelight","Faelore","Faelorin","Fahrenheit","Fairchampion","Fairfax","Fairing","Fairlane","Fairway","Fairyn","Faith","Falafel","Falcon","Falconer","Falconeye","Falconheart","Falconix","Falconstrike","Falcontech","Falconwave","Falconx","Falkner","Fallon","Family","Fan","Fanatic","Fanaticism","Fanblade","Fanciful","Fancifuland","Fancifuluxe","Fancy","Fancydream","Fancypants","Fancypetal","Fancyskies","Fancysky","Fancysong","Fancysphere","Fancywonder","Fandancer","Fandangle","Fandango","Fandazzle","Fandazzler","Fandoodle","Fanfare","Fanta","Fantasia","Fantasy","Fantom","Fanuc","Faraday","Farcaster","Fare","Farenheit","Farewell","Farley","Farlight","Farm","Farmer","Farmhouse","Farming","Farmland","Farnham","Farnsworth","Farouche","Farquhar","Farrah","Farrell","Farrow","Farscape","Farseeker","Farside","Farsider","Farsight","Farsightedness","Farskyline","Farskyscape","Farspindle","Farstar","Farsun","Fartronix","Fascination","Fashion","Fastbreak","Fastener","Fastfire","Fastfirestorm","Fastlane","Fasttrack","Fathom","Faucet","Faulkner","Faulttolerance","Faustina","Fawn","Faye","Fayeleen","Fayevel","Fearless","Fearlessknight","Feasibility","Feast","Feather","Featherbreeze","Featherdance","Featherduster","Featherflap","Featherflit","Featherfumble","Featherglide","Featherpuff","Feathers","Feathervac","Featherwhirl","Featherwhisper","Featherwisp","Federation","Feedback","Feedbacker","Feedbackix","Feedbackloop","Feedbackresistor","Feedbackrover","Feisty","Felbane","Felblade","Felcharm","Felecia","Felicia","Felicitas","Felicity","Felina","Felix","Felony","Felshadow","Felthorn","Felton","Fence","Fencerage","Fenella","Fenna","Fennec","Fennel","Fenrir","Fenton","Fenway","Fenwick","Feodora","Feral","Feralclaw","Feralhelm","Feralness","Ferdinand","Fergus","Fergusson","Fermentation","Fern","Fernanda","Ferocious","Ferocity","Ferrell","Ferret","Ferritecore","Ferrofluid","Ferrolink","Ferromatic","Ferrousmetal","Ferrousoxide","Fertile","Ferventa","Ferventis","Ferventium","Ferventor","Fervor","Fervorshield","Festival","Festus","Feybind","Feybinder","Fiana","Fianna","Fiber","Fiberblitz","Fiberboard","Fiberbundle","Fiberdroid","Fiberglass","Fiberlink","Fiberoptic","Fiberoptics","Fiberpulse","Fibersweep","Fiberswipe","Fibersync","Fibertron","Fiboguard","Fibomech","Fibosync","Fibotronix","Fibowave","Fickle","Fiction","Fiddle","Fiddleberry","Fiddledee","Fiddlefaddle","Fiddlefairy","Fiddlefancy","Fiddlefin","Fiddlefizz","Fiddlefizzle","Fiddleflame","Fiddleflash","Fiddleflutter","Fiddlefog","Fiddlefoot","Fiddlefuzz","Fiddleleaf","Fiddlemoon","Fiddlepaws","Fiddlestar","Fiddlestick","Fiddlesticks","Fiddletails","Fiddletoes","Fiddlewhirl","Fiddlewhisk","Fiddlewhisker","Fiddlewhiskers","Fiddlewhisper","Fiddlewhistle","Fiddlewiggle","Fiddlewink","Fiddlewinks","Fiddlezap","Fiddlezoom","Fidelia","Fidelina","Fidelity","Fidella","Fidelma","Fidget","Fidgetoodle","Fidgetspinner","Fidgettickle","Fidgettwirl","Fidgetwiggle","Fidgetwobble","Fidgety","Fidgetykins","Fidgitron","Fido","Field","Fieldgenerator","Fielding","Fieldprogrammable","Fieldstrength","Fiend","Fierce","Fiery","Fieryvalor","Fiesta","Fife","Fifi","Figaro","Figment","Figure","Filament","Filbert","Filch","File","Fileformat","Fileserver","Filigree","Film","Filomena","Filter","Filterpaper","Filtrabot","Filtration","Fin","Fina","Finale","Finch","Finchley","Finella","Finesse","Finger","Fingerprint","Finley","Finn","Finnegan","Finnian","Finnigan","Finnley","Finola","Finula","Fiona","Fiora","Fiorella","Fiorenza","Fire","Fireball","Firebird","Fireblade","Firebolt","Firebrand","Firecracker","Firecrest","Firedroid","Firefighter","Firefly","Fireforge","Firegloom","Fireglow","Firehawk","Fireheart","Firelight","Firelily","Firelink","Firenova","Fireplace","Firepower","Firepulse","Firestarter","Firestone","Firestorm","Firewall","Firewaller","Firewave","Fireweaver","Firewing","Firewire","Fireworks","Firmware","Firth","Fish","Fission","Fissionix","Fissionnova","Fissionova","Fissionreactor","Fitch","Fittings","Fitz","Fitzgerald","Fitzpatrick","Fitzroy","Fitzsimmons","Fiver","Fixation","Fixture","Fizz","Fizzblaster","Fizzbreeze","Fizzbuzz","Fizzgig","Fizzglide","Fizzle","Fizzleberry","Fizzlebliss","Fizzlebloom","Fizzlecharm","Fizzleclean","Fizzlefiddle","Fizzlefin","Fizzleflick","Fizzleflutter","Fizzleforge","Fizzleglow","Fizzlemech","Fizzlenaut","Fizzlenoid","Fizzlenoodle","Fizzlenook","Fizzlenookle","Fizzlenose","Fizzlenova","Fizzlenuzzle","Fizzlepaws","Fizzlepop","Fizzlesnicker","Fizzlespark","Fizzlesprite","Fizzlesquiggle","Fizzlesquirt","Fizzlestar","Fizzleswizzle","Fizzlethorn","Fizzletide","Fizzletop","Fizzletwinkle","Fizzletwist","Fizzlevortex","Fizzlewaltz","Fizzlewhirl","Fizzlewhisk","Fizzlewings","Fizzlewobble","Fizzpop","Fizzwhirl","Fizzwidget","Fizzwig","Fizzyglisten","Fizzypop","Fizzypuff","Fizzytail","Fjord","Flabbergast","Flag","Flagship","Flaherty","Flair","Flak","Flakjacket","Flame","Flamecaller","Flamecaster","Flamecloak","Flamefrost","Flamefury","Flamenco","Flamerover","Flamestalwart","Flamewrought","Flamingo","Flammablegas","Flan","Flanagan","Flange","Flannel","Flannery","Flannigan","Flap","Flaparoo","Flapdoodle","Flapdoodlefin","Flapflit","Flapjack","Flapjaws","Flapster","Flapstronaut","Flapwhisk","Flapwhisker","Flapwing","Flapwings","Flapwizzle","Flapzap","Flapzapper","Flapzephyr","Flapzilla","Flapzoodle","Flapzoom","Flapzoomer","Flapzoomster","Flapzoomzoo","Flare","Flareblade","Flareblaze","Flarebot","Flareclean","Flaredust","Flarefall","Flarefly","Flareforge","Flaregaze","Flareguard","Flaregun","Flaremaster","Flareon","Flarepulse","Flaresong","Flarestar","Flaresuck","Flaretech","Flareup","Flarewand","Flareweave","Flarewhisper","Flarewing","Flash","Flashback","Flashbolt","Flashbulb","Flashdance","Flashdrive","Flashforge","Flashglide","Flashlight","Flashmemory","Flashmob","Flashorb","Flashpoint","Flashspear","Flashstar","Flashsweep","Flashvac","Flashwave","Flashwipe","Flashy","Flatpanel","Flavia","Flavian","Flavor","Flaw","Flea","Fleck","Fleet","Fleetfoot","Fleetwood","Fleming","Fletcher","Fletchington","Fleur","Flex","Flexcable","Flexcircuit","Flexiclean","Fleximech","Flexodrive","Flexodust","Flexoduster","Flexoframe","Flexomaster","Flexopulse","Flexotronix","Flexovac","Flibbertigibbet","Flick","Flicker","Flickersweep","Flightcontrol","Flightcrew","Flightpath","Flightrecorder","Flightsimulator","Flinch","Flingo","Flint","Flinthammer","Flintshield","Flipflop","Flipper","Flippity","Flippopotamus","Flitter","Flitterbreeze","Flitterbug","Flitterfin","Flittergaze","Flitterlagoon","Flitterluxe","Flittermouse","Flitterquill","Flittertail","Flittertwirl","Flitterwings","Flitterwonder","Flitwick","Floatlink","Floatmech","Floatpulse","Floatrover","Floatswitch","Floatvalve","Flocculator","Flock","Floofalump","Floofenstein","Floofy","Floofykins","Floogle","Floor","Floozy","Floppydisk","Flopsie","Flopsy","Flopsykins","Flora","Florabell","Florence","Florianne","Florina","Flossie","Flotation","Flotationcell","Flotationdevice","Flotilla","Flotillaire","Flotillan","Flotillara","Flotillium","Flotsam","Flounder","Flow","Flowbot","Flowchart","Flowcytometer","Flowdroid","Flower","Flowmaster","Flowmeter","Flowsensor","Flowshaper","Flowtech","Flowtronix","Flowtwist","Flowweaver","Floyd","Fluctuation","Fluegas","Fluffaluffagus","Fluffball","Fluffbuster","Fluffernap","Fluffernectar","Fluffernest","Fluffernibbles","Flufferniblet","Fluffernimbus","Fluffernomad","Fluffernoodle","Fluffernook","Fluffernookle","Fluffernova","Fluffernugget","Fluffernut","Fluffernutter","Fluffernymph","Fluffinator","Flufflenoodle","Fluffmaster","Fluffy","Fluffykins","Fluffypaws","Fluffypuff","Fluffystuff","Fluffyswipe","Fluid","Fluiddynamics","Fluidicvalve","Flumblebee","Flummox","Fluorescence","Flusterfizz","Flute","Flutter","Flutteraura","Flutterby","Flutterdance","Flutterdream","Flutterflap","Flutterfuzz","Fluttergem","Flutterglim","Flutterglimmer","Flutterglow","Flutterpaws","Fluttertail","Flutterwhisk","Flutterwhisper","Fluvial","Fluxcapacitor","Fluxgate","Fluxotron","Fluzzlenose","Fly","Flyby","Flynn","Flywheel","Foal","Foam","Focallength","Focalpoint","Focus","Focusinglens","Focusingscreen","Fogbank","Foil","Folder","Foley","Folly","Fontaine","Food","Foolhardy","Footprint","Forbes","Force","Forcebot","Forcefield","Forceps","Forcepulse","ForceRider","Forcerover","Forcesensor","Forcetransducer","Forecast","Forecaster","Forefront","Forehead","Foreman","Forensics","Foresight","Forester","Fork","Forklift","Form","Formadroid","Formamech","Formation","Formationflying","Formatron","Formawave","Formfactor","Formula","Formulation","Fornax","Fornaxar","Fornexia","Fornexis","Forsake","Forsaken","Forsyth","Forsythe","Fortescue","Fortitude","Fortuna","Fortune","Fossil","Foster","Foundation","Fountain","Fowler","Foxy","Fractal","Fractalbot","Fractalix","Fractaloid","Fractalys","Fractious","Fracture","Fragile","Fragment","Fragmentation","Frame","Framebot","Framebuffer","Framegrabber","Framerate","Framesync","Framewave","Framework","Framex","Frances","Francesca","Francette","Franco","Frankie","Franklin","Franks","Frannie","Franny","Fraser","Frasier","Fraternity","Freckle","Freckles","Freddie","Freedom","Freefall","Freefalling","Freeman","Freesia","Freewheel","Freight","Freighter","Frenetic","Frenzy","Frenzysword","Frequency","Frequencyband","Frequencyconverter","Frequencycounter","Frequencymodulation","Frequencymodulator","Frequencymultiplier","Fresh","Frey","Freya","Freyrider","Friction","Frictionator","Frictionix","Frictionless","Fridge","Friend","Frightening","Frightful","Fringe","Frisbee","Frisky","Frit","Fritter","Frivolitea","Frivolity","Frizzle","Frobisher","Frodo","Frolic","Frolicdelight","Frolicfluff","Frolicfrost","Frolicorama","Frolicscape","Frolicscent","Frolicshine","Frolicsilk","Frolicwhimsy","Frollicker","Frollicky","Frontier","Frontiersman","Frontpanel","Frost","Frostcloak","Frostcrystal","Frosted","Frostfable","Frostfang","Frostflurry","Frostfury","Frosthaven","Frostjewel","Frostshield","Frostspell","Frostthorn","Frostward","Frostwhisper","Frosty","Frostypromise","Frostythorn","Froth","Frothberry","Frothyspark","Frothysparkle","Frothyspritz","Frothywhimsy","Froyo","Fuchsia","Fuddle","Fuddlepaws","Fudge","Fudgefin","Fudgepaws","Fuego","Fuel","Fuelarium","Fuelcell","Fuelcellstack","Fuelefficiency","Fuelfilter","Fuelgauge","Fuelinjection","Fuelix","Fuellink","Fuelmaster","Fuelora","Fuelpump","Fuelrider","Fuelrover","Fueltank","Fueltron","Fuelwave","Fugitive","Fulcrum","Fulfillment","Fulgensia","Fulgentis","Fulgurian","Fulgurion","Fulmination","Fulton","Fumble","Fumbleblitz","Fumbledust","Fumblefizz","Fumbleflutter","Fumbleglim","Fumblemop","Fumblesweep","Fumblewhir","Fumblewhirl","Fumblewizzle","Fume","Fumeextractor","Fumehood","Funbot","Functionality","Functionalitytest","Functionator","Functioneer","Functiongenerator","Functionix","Functionoid","Fund","Fungus","Funky","Funnybone","Funnyface","Fur","Furball","Furberry","Furberrypaws","Furberrytail","Furberrywhisk","Furblaster","Furlong","Furniture","Furrball","Furrnoodle","Furrow","Furrpaws","Furrwhisk","Furrwhisker","Furrwings","Furry","Furryfin","Furryfizzle","Furryflap","Furryflick","Furrymop","Furrypaws","Furrytail","Furrywand","Furrywhir","Furrywhirl","Furrywhisk","Furtive","Furtively","Furtiveness","Fury","Furyblade","Furyclad","Fuse","Fusebox","Fuselage","Fusion","Fusionair","Fusionara","Fusionator","Fusionenergy","Fusionis","Fusionix","Fusionlink","Fusionmech","Fusionoid","Fusionreactor","Fusionwave","Futurabot","Futurarover","Futurasync","Futuratech","Futurawave","Future","Futurion","Futuromech","Futurosync","Fuzion","Fuzz","Fuzzball","Fuzzbert","Fuzzbucket","Fuzzeater","Fuzzinator","Fuzzington","Fuzzleflap","Fuzzleflick","Fuzzlenoodle","Fuzzlenook","Fuzzlenose","Fuzzlepaws","Fuzzlesuck","Fuzzletail","Fuzzlewhir","Fuzzlewhirl","Fuzzlewhisk","Fuzznugget","Fuzzpaw","Fuzzpop","Fuzzums","Fuzzwuzzle","Fuzzy","Fuzzydazzle","Fuzzyfin","Fuzzykins","Fuzzynectar","Fuzzynibble","Fuzzypaws","Fuzzypetal","Fuzzypop","Fuzzypuff","Fuzzysnuggle","Fuzzysprite","Fuzzysquirt","Fuzzyswirl","Fuzzyswizzle","Fuzzyswoop"};

  public static void main(String[] args) {
    System.out.println("adjectives: "+ADJECTIVES.length);
    Arrays.stream(ADJECTIVES).forEach(v -> System.out.print(v+","));
    System.out.println("\nnouns a: "+NOUNS_A.length);
    Arrays.stream(NOUNS_A).forEach(v -> System.out.print(v+","));
    System.out.println("\nnouns b: "+NOUNS_B.length);
    Arrays.stream(NOUNS_B).forEach(v -> System.out.print(v+","));
    System.out.println("\nnouns d: "+NOUNS_D.length);
    Arrays.stream(NOUNS_D).forEach(v -> System.out.print(v+","));
    System.out.println("\nnouns f: "+NOUNS_F.length);
    Arrays.stream(NOUNS_F).forEach(v -> System.out.print(v+","));
  }
}
